Index: CKEditor/trunk/_source/plugins/richcombo/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/richcombo/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/richcombo/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -45,4 +45,9 @@
 
 		panelDefinition.className = ( panelDefinition.className || '' ) + ' cke_rcombopanel';
+		panelDefinition.block =
+		{
+			multiSelect : panelDefinition.multiSelect,
+			attributes : panelDefinition.attributes
+		};
 
 		this._ =
@@ -84,4 +89,6 @@
 		render : function( editor, output )
 		{
+			var env = CKEDITOR.env;
+
 			var id = 'cke_' + this.id;
 			var clickFn = CKEDITOR.tools.addFunction( function( $element )
@@ -163,7 +170,9 @@
 
 			output.push(
-				'>' +
-					'<span class=cke_label>', this.label, '</span>' +
-					'<a hidefocus=true title="', this.title, '" tabindex="-1" href="javascript:void(\'', this.label, '\')"' );
+				'>',
+					'<span id="' + id+ '_label" class=cke_label>', this.label, '</span>',
+					'<a hidefocus=true title="', this.title, '" tabindex="-1"',
+						env.gecko && env.version >= 10900 && !env.hc ? '' : ' href="javascript:void(\'' + this.label + '\')"',
+						' role="button" aria-labelledby="', id , '_label" aria-describedby="', id, '_text" aria-haspopup="true"' );
 
 			// Some browsers don't cancel key events in the keydown but in the
@@ -188,8 +197,7 @@
 					' onclick="CKEDITOR.tools.callFunction(', clickFn, ', this); return false;">' +
 						'<span>' +
-							'<span class="cke_accessibility">' + ( this.voiceLabel ? this.voiceLabel + ' ' : '' ) + '</span>' +
 							'<span id="' + id + '_text" class="cke_text cke_inline_label">' + this.label + '</span>' +
 						'</span>' +
-						'<span class=cke_openbutton></span>' +
+						'<span class=cke_openbutton>' + ( CKEDITOR.env.hc ? '<span>&#9660;</span>' : '' ) + '</span>' +	// BLACK DOWN-POINTING TRIANGLE
 					'</a>' +
 				'</span>' +
@@ -208,7 +216,8 @@
 
 			var panelDefinition = this._.panelDefinition,
+				panelBlockDefinition = this._.panelDefinition.block,
 				panelParentElement = panelDefinition.parent || CKEDITOR.document.getBody(),
 				panel = new CKEDITOR.ui.floatPanel( editor, panelParentElement, panelDefinition ),
-				list = panel.addListBlock( this.id, this.multiSelect ),
+				list = panel.addListBlock( this.id, panelBlockDefinition ),
 				me = this;
 
@@ -291,4 +300,5 @@
 			else
 				textElement.removeClass( 'cke_inline_label' );
+
 			textElement.setHtml( typeof text != 'undefined' ? text : value );
 		},
Index: CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js
===================================================================
--- CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/smiley/dialogs/smiley.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -7,4 +7,5 @@
 {
 	var config = editor.config,
+		lang = editor.lang.smiley,
 		images = config.smiley_images,
 		columns = 8,
@@ -57,24 +58,4 @@
 		switch ( keystroke )
 		{
-			// RIGHT-ARROW
-			case 39 :
-				// relative is TD
-				if ( ( relative = element.getParent().getNext() ) )
-				{
-					nodeToMove = relative.getChild( 0 );
-					nodeToMove.focus();
-				}
-				ev.preventDefault();
-				break;
-			// LEFT-ARROW
-			case 37 :
-				// relative is TD
-				if ( ( relative = element.getParent().getPrevious() ) )
-				{
-					nodeToMove = relative.getChild( 0 );
-					nodeToMove.focus();
-				}
-				ev.preventDefault();
-				break;
 			// UP-ARROW
 			case 38 :
@@ -104,4 +85,7 @@
 				ev.preventDefault();
 				break;
+
+			// RIGHT-ARROW
+			case 39 :
 			// TAB
 			case 9 :
@@ -122,4 +106,7 @@
 				}
 				break;
+
+			// LEFT-ARROW
+			case 37 :
 			// SHIFT + TAB
 			case CKEDITOR.SHIFT + 9 :
@@ -148,10 +135,13 @@
 	var html =
 	[
-		'<table cellspacing="2" cellpadding="2"',
+		'<div>' +
+		'<span id="smiley_emtions_label" class="cke_voice_label">' + editor.lang.common.options +'</span>',
+		'<table role="listbox" aria-labelledby="smiley_emtions_label" style="width:100%;height:100%" cellspacing="2" cellpadding="2"',
 		CKEDITOR.env.ie && CKEDITOR.env.quirks ? ' style="position:absolute;"' : '',
 		'><tbody>'
 	];
 
-	for ( i = 0 ; i < images.length ; i++ )
+	var size = images.length;
+	for ( i = 0 ; i < size ; i++ )
 	{
 		if ( i % columns === 0 )
@@ -160,5 +150,9 @@
 		html.push(
 			'<td class="cke_dark_background cke_hand cke_centered" style="vertical-align: middle;">' +
-				'<a href="javascript:void(0)" class="cke_smile" tabindex="-1" onkeydown="CKEDITOR.tools.callFunction( ', onKeydown, ', event, this );">',
+				'<a href="javascript:void(0)" role="option"',
+					' aria-posinset="' + ( i +1 ) + '"',
+					' aria-setsize="' + size + '"',
+					' aria-labelledby="cke_smile_label_' + i + '"',
+					' class="cke_smile" tabindex="-1" onkeydown="CKEDITOR.tools.callFunction( ', onKeydown, ', event, this );">',
 					'<img class="hand" title="', config.smiley_descriptions[i], '"' +
 						' cke_src="', CKEDITOR.tools.htmlEncode( config.smiley_path + images[ i ] ), '" alt="', config.smiley_descriptions[i], '"',
@@ -167,4 +161,5 @@
 						( CKEDITOR.env.ie ? ' onload="this.setAttribute(\'width\', 2); this.removeAttribute(\'width\');" ' : '' ),
 					'>' +
+					'<span id="cke_smile_label_' + i + '" class="cke_voice_label">' +config.smiley_descriptions[ i ]  + '</span>' +
 				'</a>',
  			'</td>' );
@@ -181,5 +176,5 @@
 	}
 
-	html.push( '</tbody></table>' );
+	html.push( '</tbody></table></div>' );
 
 	var smileySelector =
@@ -193,5 +188,5 @@
 		focus : function()
  		{
-			var firstSmile = this.getElement().getChild( [0, 0, 0, 0] );
+			var firstSmile = this.getElement().getElementsByTag( 'a' ).getItem( 0 );
 			firstSmile.focus();
  		},
Index: CKEditor/trunk/_source/plugins/smiley/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/smiley/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/smiley/plugin.js	(revision 5189)
@@ -60,16 +60,26 @@
  * setting.
  * @type Array
- * @default (see example)
+ * @default  The textual descriptions of smiley.
  * @example
- * // This is actually the default value.
- * config.smiley_descriptions = [
- *     ':)', ':(', ';)', ':D', ':/', ':P',
- *     '', '', '', '', '', '',
- *     '', ';(', '', '', '', '',
- *     '', ':kiss', '' ];
+ * // Default settings.
+ * config.smiley_descriptions =
+ *     [
+ *         'smiley', 'sad', 'wink', 'laugh', 'frown', 'cheeky', 'blush', 'surprise',
+ *         'indecision', 'angry', 'angle', 'cool', 'devil', 'crying', 'enlightened', 'no',
+ *         'yes', 'heart', 'broken heart', 'kiss', 'mail'
+ *     ];
+ * @example
+ * // Use textual emoticons as description.
+ * config.smiley_descriptions =
+ *     [
+ *         ':)', ':(', ';)', ':D', ':/', ':P', ':*)', ':-o',
+ *         ':|', '>:(', 'o:)', '8-)', '>:-)', ';(', '', '', '',
+ *         '', '', ':-*', ''
+ *     ];
  */
-CKEDITOR.config.smiley_descriptions = [
-	':)', ':(', ';)', ':D', ':/', ':P',
-	'', '', '', '', '', '',
-	'', ';(', '', '', '', '',
-	'', ':kiss', '' ];
+CKEDITOR.config.smiley_descriptions =
+	[
+		'smiley', 'sad', 'wink', 'laugh', 'frown', 'cheeky', 'blush', 'surprise',
+		'indecision', 'angry', 'angle', 'cool', 'devil', 'crying', 'enlightened', 'no',
+		'yes', 'heart', 'broken heart', 'kiss', 'mail'
+	];
Index: CKEditor/trunk/_source/plugins/sourcearea/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/sourcearea/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/sourcearea/plugin.js	(revision 5189)
@@ -1,3 +1,3 @@
-﻿/*
+/*
 Copyright (c) 2003-2010, CKSource - Frederico Knabben. All rights reserved.
 For licensing, see LICENSE.html or http://ckeditor.com/license
@@ -35,5 +35,7 @@
 								{
 									dir : 'ltr',
-									tabIndex : -1
+									tabIndex : editor.tabIndex,
+									'role' : 'textbox',
+									'aria-label' : editor.lang.editorTitle.replace( '%1', editor.name )
 								});
 							textarea.addClass( 'cke_source' );
@@ -88,4 +90,6 @@
 							holderElement.append( textarea );
 							textarea.setStyles( styles );
+
+							editor.fire( 'ariaWidget', textarea );
 
 							textarea.on( 'blur', function()
Index: CKEditor/trunk/_source/plugins/specialchar/dialogs/specialchar.js
===================================================================
--- CKEditor/trunk/_source/plugins/specialchar/dialogs/specialchar.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/specialchar/dialogs/specialchar.js	(revision 5189)
@@ -10,5 +10,6 @@
 	 * @type {CKEDITOR.dialog}
 	 */
-	var dialog;
+	var dialog,
+		lang = editor.lang.specialChar;
 	var onChoice = function( evt )
 	{
@@ -84,31 +85,4 @@
 		switch ( keystroke )
 		{
-			// RIGHT-ARROW
-			case 39 :
-				// relative is TD
-				if ( ( relative = element.getParent().getNext() ) )
-				{
-					nodeToMove = relative.getChild( 0 );
-					if ( nodeToMove.type == 1 )
-					{
-						nodeToMove.focus();
-						onBlur( null, element );
-						onFocus( null, nodeToMove );
-					}
-				}
-				ev.preventDefault();
-				break;
-			// LEFT-ARROW
-			case 37 :
-				// relative is TD
-				if ( ( relative = element.getParent().getPrevious() ) )
-				{
-					nodeToMove = relative.getChild( 0 );
-					nodeToMove.focus();
-					onBlur( null, element );
-					onFocus( null, nodeToMove );
-				}
-				ev.preventDefault();
-				break;
 			// UP-ARROW
 			case 38 :
@@ -144,4 +118,7 @@
 				ev.preventDefault();
 				break;
+
+			// RIGHT-ARROW
+			case 39 :
 			// TAB
 			case 9 :
@@ -175,4 +152,7 @@
 				}
 				break;
+
+			// LEFT-ARROW
+			case 37 :
 			// SHIFT + TAB
 			case CKEDITOR.SHIFT + 9 :
@@ -205,5 +185,5 @@
 
 	return {
-		title : editor.lang.specialChar.title,
+		title : lang.title,
 		minWidth : 430,
 		minHeight : 280,
@@ -220,24 +200,31 @@
 				'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p',
 				'q','r','s','t','u','v','w','x','y','z',
-				'{','|','}','~','&euro;','&lsquo;','&rsquo;','&rsquo;','&ldquo;',
-				'&rdquo;','&ndash;','&mdash;','&iexcl;','&cent;','&pound;',
-				'&curren;','&yen;','&brvbar;','&sect;','&uml;','&copy;','&ordf;',
-				'&laquo;','&not;','&reg;','&macr;','&deg;','&plusmn;','&sup2;',
-				'&sup3;','&acute;','&micro;','&para;','&middot;','&cedil;',
-				'&sup1;','&ordm;','&raquo;','&frac14;','&frac12;','&frac34;',
-				'&iquest;','&Agrave;','&Aacute;','&Acirc;','&Atilde;','&Auml;',
-				'&Aring;','&AElig;','&Ccedil;','&Egrave;','&Eacute;','&Ecirc;',
-				'&Euml;','&Igrave;','&Iacute;','&Icirc;','&Iuml;','&ETH;',
-				'&Ntilde;','&Ograve;','&Oacute;','&Ocirc;','&Otilde;','&Ouml;',
-				'&times;','&Oslash;','&Ugrave;','&Uacute;','&Ucirc;','&Uuml;',
-				'&Yacute;','&THORN;','&szlig;','&agrave;','&aacute;','&acirc;',
-				'&atilde;','&auml;','&aring;','&aelig;','&ccedil;','&egrave;',
-				'&eacute;','&ecirc;','&euml;','&igrave;','&iacute;','&icirc;',
-				'&iuml;','&eth;','&ntilde;','&ograve;','&oacute;','&ocirc;',
-				'&otilde;','&ouml;','&divide;','&oslash;','&ugrave;','&uacute;',
-				'&ucirc;','&uuml;','&uuml;','&yacute;','&thorn;','&yuml;',
-				'&OElig;','&oelig;','&#372;','&#374','&#373','&#375;','&sbquo;',
-				'&#8219;','&bdquo;','&hellip;','&trade;','&#9658;','&bull;',
-				'&rarr;','&rArr;','&hArr;','&diams;','&asymp;'
+				'{','|','}','~','&euro;(EURO SIGN)','&lsquo;(LEFT SINGLE QUOTATION MARK)','&rsquo;(RIGHT SINGLE QUOTATION MARK)','&ldquo;(LEFT DOUBLE QUOTATION MARK)',
+				'&rdquo;(RIGHT DOUBLE QUOTATION MARK)','&ndash;(EN DASH)','&mdash;(EM DASH)','&iexcl;(INVERTED EXCLAMATION MARK)','&cent;(CENT SIGN)','&pound;(POUND SIGN)',
+				'&curren;(CURRENCY SIGN)','&yen;(YEN SIGN)','&brvbar;(BROKEN BAR)','&sect;(SECTION SIGN)','&uml;(DIAERESIS)','&copy;(COPYRIGHT SIGN)','&ordf;(FEMININE ORDINAL INDICATOR)',
+				'&laquo;(LEFT-POINTING DOUBLE ANGLE QUOTATION MARK)','&not;(NOT SIGN)','&reg;(REGISTERED SIGN)','&macr;(MACRON)','&deg;(DEGREE SIGN)','&plusmn;(PLUS-MINUS SIGN)','&sup2;(SUPERSCRIPT TWO)',
+				'&sup3;(SUPERSCRIPT THREE)','&acute;(ACUTE ACCENT)','&micro;(MICRO SIGN)','&para;(PILCROW SIGN)','&middot;(MIDDLE DOT)','&cedil;(CEDILLA)',
+				'&sup1;(SUPERSCRIPT ONE)','&ordm;(MASCULINE ORDINAL INDICATOR)','&raquo;(RIGHT-POINTING DOUBLE ANGLE QUOTATION MARK)','&frac14;(VULGAR FRACTION ONE QUARTER)','&frac12;(VULGAR FRACTION ONE HALF)','&frac34;(VULGAR FRACTION THREE QUARTERS)',
+				'&iquest;(INVERTED QUESTION MARK)','&Agrave;(LATIN CAPITAL LETTER A WITH GRAVE)','&Aacute;(LATIN CAPITAL LETTER A WITH ACUTE)','&Acirc;(LATIN CAPITAL LETTER A WITH CIRCUMFLEX)','&Atilde;(LATIN CAPITAL LETTER A WITH TILDE)','&Auml;(LATIN CAPITAL LETTER A WITH DIAERESIS)',
+				'&Aring;(LATIN CAPITAL LETTER A WITH RING ABOVE)','&AElig;(LATIN CAPITAL LETTER AE)','&Ccedil;(LATIN CAPITAL LETTER C WITH CEDILLA)','&Egrave;(LATIN CAPITAL LETTER E WITH GRAVE)','&Eacute;(LATIN CAPITAL LETTER E WITH ACUTE)','&Ecirc;(LATIN CAPITAL LETTER E WITH CIRCUMFLEX)',
+				'&Euml;(LATIN CAPITAL LETTER E WITH DIAERESIS)','&Igrave;(LATIN CAPITAL LETTER I WITH GRAVE)','&Iacute;(LATIN CAPITAL LETTER I WITH ACUTE)','&Icirc;(LATIN CAPITAL LETTER I WITH CIRCUMFLEX)','&Iuml;(LATIN CAPITAL LETTER I WITH DIAERESIS)','&ETH;(LATIN CAPITAL LETTER ETH)',
+				'&Ntilde;(LATIN CAPITAL LETTER N WITH TILDE)','&Ograve;(LATIN CAPITAL LETTER O WITH GRAVE)','&Oacute;(LATIN CAPITAL LETTER O WITH ACUTE)','&Ocirc;(LATIN CAPITAL LETTER O WITH CIRCUMFLEX)','&Otilde;(LATIN CAPITAL LETTER O WITH TILDE)','&Ouml;(LATIN CAPITAL LETTER O WITH DIAERESIS)',
+				'&times;(MULTIPLICATION SIGN)','&Oslash;(LATIN CAPITAL LETTER O WITH STROKE)','&Ugrave;(LATIN CAPITAL LETTER U WITH GRAVE)','&Uacute;(LATIN CAPITAL LETTER U WITH ACUTE)','&Ucirc;(LATIN CAPITAL LETTER U WITH CIRCUMFLEX)','&Uuml;(LATIN CAPITAL LETTER U WITH DIAERESIS)',
+				'&Yacute;(LATIN CAPITAL LETTER Y WITH ACUTE)','&THORN;(LATIN CAPITAL LETTER THORN)','&szlig;(LATIN SMALL LETTER SHARP S)','&agrave;(LATIN SMALL LETTER A WITH GRAVE)','&aacute;(LATIN SMALL LETTER A WITH ACUTE)','&acirc;(LATIN SMALL LETTER A WITH CIRCUMFLEX)',
+				'&atilde;(LATIN SMALL LETTER A WITH TILDE)','&auml;(LATIN SMALL LETTER A WITH DIAERESIS)','&aring;(LATIN SMALL LETTER A WITH RING ABOVE)','&aelig;(LATIN SMALL LETTER AE)','&ccedil;(LATIN SMALL LETTER C WITH CEDILLA)','&egrave;(LATIN SMALL LETTER E WITH GRAVE)',
+				'&eacute;(LATIN SMALL LETTER E WITH ACUTE)','&ecirc;(LATIN SMALL LETTER E WITH CIRCUMFLEX)','&euml;(LATIN SMALL LETTER E WITH DIAERESIS)','&igrave;(LATIN SMALL LETTER I WITH GRAVE)','&iacute;(LATIN SMALL LETTER I WITH ACUTE)','&icirc;(LATIN SMALL LETTER I WITH CIRCUMFLEX)',
+				'&iuml;(LATIN SMALL LETTER I WITH DIAERESIS)','&eth;(LATIN SMALL LETTER ETH)','&ntilde;(LATIN SMALL LETTER N WITH TILDE)','&ograve;(LATIN SMALL LETTER O WITH GRAVE)','&oacute;(LATIN SMALL LETTER O WITH ACUTE)','&ocirc;(LATIN SMALL LETTER O WITH CIRCUMFLEX)',
+				'&otilde;(LATIN SMALL LETTER O WITH TILDE)','&ouml;(LATIN SMALL LETTER O WITH DIAERESIS)',
+				'&divide;(DIVISION SIGN)','&oslash;(LATIN SMALL LETTER O WITH STROKE)',
+				'&ugrave;(LATIN SMALL LETTER U WITH GRAVE)','&uacute;(LATIN SMALL LETTER U WITH ACUTE)',
+				'&ucirc;(LATIN SMALL LETTER U WITH CIRCUMFLEX)','&uuml;(LATIN SMALL LETTER U WITH DIAERESIS)',
+				'&uuml;(LATIN SMALL LETTER U WITH DIAERESIS)','&yacute;(LATIN SMALL LETTER Y WITH ACUTE)','&thorn;(LATIN SMALL LETTER THORN)','&yuml;(LATIN SMALL LETTER Y WITH DIAERESIS)',
+				'&OElig;(LATIN CAPITAL LIGATURE OE)',
+				'&oelig;(LATIN SMALL LIGATURE OE)','&#372;(LATIN CAPITAL LETTER W WITH CIRCUMFLEX)',
+				'&#374(LATIN CAPITAL LETTER Y WITH CIRCUMFLEX)','&#373(LATIN SMALL LETTER W WITH CIRCUMFLEX)',
+				'&#375;(LATIN SMALL LETTER Y WITH CIRCUMFLEX)','&sbquo;(SINGLE LOW-9 QUOTATION MARK)',
+				'&#8219;(SINGLE HIGH-REVERSED-9 QUOTATION MARK)','&bdquo;(DOUBLE LOW-9 QUOTATION MARK)','&hellip;(HORIZONTAL ELLIPSIS)',
+				'&trade;(TRADE MARK SIGN)','&#9658;(BLACK RIGHT-POINTING POINTER)','&bull;(BULLET)',
+				'&rarr;(RIGHTWARDS ARROW)','&rArr;(RIGHTWARDS DOUBLE ARROW)','&hArr;(LEFT RIGHT DOUBLE ARROW)','&diams;(BLACK DIAMOND SUIT)','&asymp;(ALMOST EQUAL TO)'
 			],
 		onLoad :  function()
@@ -246,8 +233,14 @@
 				chars = this.definition.chars;
 
-			var html = [ '<table style="width: 320px; height: 100%; border-collapse: separate;" align="center" cellspacing="2" cellpadding="2" border="0">' ];
-
-			var i = 0 ;
-			while ( i < chars.length )
+			var html = [ '<table role="listbox" aria-labelledby="specialchar_table_label"' +
+						 			' style="width: 320px; height: 100%; border-collapse: separate;"' +
+						 			' align="center" cellspacing="2" cellpadding="2" border="0">' ];
+
+			var i = 0,
+				size = chars.length,
+				character,
+				charDesc;
+
+			while ( i < size )
 			{
 				html.push( '<tr>' ) ;
@@ -255,14 +248,31 @@
 				for ( var j = 0 ; j < columns ; j++, i++ )
 				{
-					if ( chars[ i ] )
-					{
+					if ( ( character = chars[ i ] ) )
+					{
+						charDesc = '';
+						character = character.replace( /\((.*?)\)/, function( match, desc )
+							{
+								charDesc = desc;
+								return '';
+							} );
+
+						// Use character in case description unavailable.
+						charDesc = charDesc || character;
+
 						html.push(
 							'<td class="cke_dark_background" style="cursor: default">' +
-							'<a href="javascript: void(0);" style="cursor: inherit; display: block; height: 1.25em; margin-top: 0.25em; text-align: center;" title="', chars[i].replace( /&/g, '&amp;' ), '"' +
+							'<a href="javascript: void(0);" role="option"' +
+							' aria-posinset="' + ( i +1 ) + '"',
+							' aria-setsize="' + size + '"',
+							' aria-labelledby="cke_specialchar_label_' + i + '"',
+							' style="cursor: inherit; display: block; height: 1.25em; margin-top: 0.25em; text-align: center;" title="', CKEDITOR.tools.htmlEncode( charDesc ), '"' +
 							' onkeydown="CKEDITOR.tools.callFunction( ' + onKeydown + ', event, this )"' +
 							' onclick="CKEDITOR.tools.callFunction(' + onClick + ', this); return false;"' +
 							' tabindex="-1">' +
 							'<span style="margin: 0 auto;cursor: inherit">' +
-							chars[i] +
+							character +
+							'</span>' +
+							'<span class="cke_voice_label" id="cke_specialchar_label_' + i + '">' +
+							charDesc +
 							'</span></a>');
 					}
@@ -275,5 +285,5 @@
 			}
 
-			html.push( '</tbody></table>' );
+			html.push( '</tbody></table>', '<span id="specialchar_table_label" class="cke_voice_label">' + editor.lang.common.options +'</span>' );
 
 			this.getContentElement( 'info', 'charContainer' ).getElement().setHtml( html.join( '' ) );
@@ -301,5 +311,5 @@
 								focus : function()
 								{
-									var firstChar = this.getElement().getChild( [0, 0, 0, 0, 0] );
+									var firstChar = this.getElement().getElementsByTag( 'a' ).getItem( 0 );
 									setTimeout(function()
 									{
@@ -308,13 +318,12 @@
 									});
 								},
-								// Needed only for webkit.
 								onShow : function()
 								{
-									var firstChar = this.getElement().getChild( [0, 0, 0, 0, 0] );
-									setTimeout(function()
-									{
-										firstChar.focus();
-										onFocus( null, firstChar );
-									});
+									var firstChar = this.getElement().getChild( [ 0, 0, 0, 0, 0 ] );
+									setTimeout( function()
+										{
+											firstChar.focus();
+											onFocus( null, firstChar );
+										});
 								},
 								onLoad : function( event )
Index: CKEditor/trunk/_source/plugins/styles/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/styles/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/styles/plugin.js	(revision 5189)
@@ -1247,2 +1247,4 @@
 	return !!doc;
 };
+
+CKEDITOR.stylesSet = new CKEDITOR.resourceManager( '', 'stylesSet' );
Index: CKEditor/trunk/_source/plugins/stylescombo/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/stylescombo/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/stylescombo/plugin.js	(revision 5189)
@@ -6,4 +6,6 @@
 (function()
 {
+	var stylesManager;
+
 	CKEDITOR.plugins.add( 'stylescombo',
 	{
@@ -17,32 +19,47 @@
 				styles;
 
+			if ( !stylesManager )
+			{
+				stylesManager = CKEDITOR.stylesSet;
+
+				// Backward compatibilities (#5025).
+				CKEDITOR.addStylesSet = CKEDITOR.tools.bind( stylesManager.add, stylesManager );
+				CKEDITOR.loadStylesSet = function( name, url, callback )
+					{
+						stylesManager.addExternal( name, url, '' );
+						CKEDITOR.stylesSet.load( name, callback );
+					};
+			}
+
+			var comboStylesSet = config.stylesCombo_stylesSet.split( ':' ),
+				styleSetName = comboStylesSet[ 0 ],
+				externalPath = comboStylesSet[ 1 ];
+
+			stylesManager.addExternal( styleSetName,
+					externalPath ?
+						comboStylesSet.slice( 1 ).join( ':' ) :
+						pluginPath + 'styles/' + styleSetName + '.js', '' );
+
 			editor.ui.addRichCombo( 'Styles',
 				{
 					label : lang.label,
 					title : lang.panelTitle,
-					voiceLabel : lang.voiceLabel,
 					className : 'cke_styles',
-					multiSelect : true,
 
 					panel :
 					{
 						css : editor.skin.editor.css.concat( config.contentsCss ),
-						voiceLabel : lang.panelVoiceLabel
+						multiSelect : true,
+						attributes : { 'aria-label' : lang.panelTitle }
 					},
 
 					init : function()
 					{
-						var combo = this,
-							stylesSet = config.stylesCombo_stylesSet.split( ':' );
-
-						var stylesSetPath = stylesSet[ 1 ] ?
-								stylesSet.slice( 1 ).join( ':' ) :		// #4481
-								CKEDITOR.getUrl( pluginPath + 'styles/' + stylesSet[ 0 ] + '.js' ) ;
-
-						stylesSet = stylesSet[ 0 ];
-
-						CKEDITOR.loadStylesSet( stylesSet, stylesSetPath, function( stylesDefinitions )
-							{
-								var style,
+						var combo = this;
+
+						CKEDITOR.stylesSet.load( styleSetName, function( stylesSet )
+							{
+								var stylesDefinitions = stylesSet[ styleSetName ],
+									style,
 									styleName,
 									stylesList = [];
@@ -207,27 +224,4 @@
 		}
 	});
-
-	var stylesSets = {};
-
-	CKEDITOR.addStylesSet = function( name, styles )
-	{
-		stylesSets[ name ] = styles;
-	};
-
-	CKEDITOR.loadStylesSet = function( name, url, callback )
-	{
-		var stylesSet = stylesSets[ name ];
-
-		if ( stylesSet )
-		{
-			callback( stylesSet );
-			return ;
-		}
-
-		CKEDITOR.scriptLoader.load( url, function()
-			{
-				callback( stylesSets[ name ] );
-			});
-	};
 
 	function buildPreview( styleDefinition )
Index: CKEditor/trunk/_source/plugins/stylescombo/styles/default.js
===================================================================
--- CKEditor/trunk/_source/plugins/stylescombo/styles/default.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/stylescombo/styles/default.js	(revision 5189)
@@ -4,5 +4,5 @@
 */
 
-CKEDITOR.addStylesSet( 'default',
+CKEDITOR.stylesSet.add( 'default',
 [
 	/* Block Styles */
Index: CKEditor/trunk/_source/plugins/tab/plugin.js
===================================================================
--- CKEditor/trunk/_source/plugins/tab/plugin.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/tab/plugin.js	(revision 5189)
@@ -16,5 +16,5 @@
 			exec : function( editor )
 			{
-				editor.container.focusNext( true );
+				editor.container.focusNext( true, editor.tabIndex );
 			}
 		};
@@ -24,5 +24,5 @@
 			exec : function( editor )
 			{
-				editor.container.focusPrevious( true );
+				editor.container.focusPrevious( true, editor.tabIndex );
 			}
 		};
@@ -34,10 +34,5 @@
 		init : function( editor )
 		{
-			// Register the keystrokes.
-			var keystrokes = editor.keystrokeHandler.keystrokes;
-			keystrokes[ 9 /* TAB */ ] = 'tab';
-			keystrokes[ CKEDITOR.SHIFT + 9 /* TAB */ ] = 'shiftTab';
-
-			var tabSpaces = editor.config.tabSpaces,
+			var tabSpaces = editor.config.tabSpaces || 0,
 				tabText = '';
 
@@ -45,41 +40,35 @@
 				tabText += '\xa0';
 
-			// Register the "tab" and "shiftTab" commands.
-			editor.addCommand( 'tab', CKEDITOR.tools.extend(
-				{
-					exec : function( editor )
+			if ( tabText )
+			{
+				editor.on( 'key', function( ev )
 					{
-						// Fire the "tab" event, making it possible to
-						// customize the TAB key behavior on specific cases.
-						if ( !editor.fire( 'tab' ) )
+						if ( ev.data.keyCode == 9 )	// TAB
 						{
-							if ( tabText.length > 0 )
-								editor.insertHtml( tabText );
-							else
-							{
-								// All browsers jump to the next field on TAB,
-								// except Safari, so we have to do that manually
-								// here.
-								/// https://bugs.webkit.org/show_bug.cgi?id=20597
-								return editor.execCommand( 'blur' );
-							}
+							editor.insertHtml( tabText );
+							ev.cancel();
 						}
-
-						return true;
-					}
-				}, meta ) );
-
-			editor.addCommand( 'shiftTab', CKEDITOR.tools.extend(
-				{
-					exec : function( editor )
+					});
+			}
+
+			if ( CKEDITOR.env.webkit )
+			{
+				editor.on( 'key', function( ev )
 					{
-						// Fire the "tab" event, making it possible to
-						// customize the TAB key behavior on specific cases.
-						if ( !editor.fire( 'shiftTab' ) )
-							return editor.execCommand( 'blurBack' );
-
-						return true;
-					}
-				}, meta ) );
+						var keyCode = ev.data.keyCode;
+
+						if ( keyCode == 9 && !tabText )				// TAB
+						{
+							ev.cancel();
+							editor.execCommand( 'blur' );
+						}
+
+						if ( keyCode == ( CKEDITOR.SHIFT + 9 ) )	// SHIFT+TAB
+						{
+							editor.execCommand( 'blurBack' );
+							ev.cancel();
+						}
+					});
+			}
 
 			editor.addCommand( 'blur', CKEDITOR.tools.extend( blurCommand, meta ) );
@@ -96,8 +85,8 @@
  * element.focusNext();
  */
-CKEDITOR.dom.element.prototype.focusNext = function( ignoreChildren )
+CKEDITOR.dom.element.prototype.focusNext = function( ignoreChildren, indexToUse )
 {
 	var $ = this.$,
-		curTabIndex = this.getTabIndex(),
+		curTabIndex = ( indexToUse === undefined ? this.getTabIndex() : indexToUse ),
 		passedCurrent, enteredCurrent,
 		elected, electedTabIndex,
@@ -184,8 +173,8 @@
  * element.focusPrevious();
  */
-CKEDITOR.dom.element.prototype.focusPrevious = function( ignoreChildren )
+CKEDITOR.dom.element.prototype.focusPrevious = function( ignoreChildren, indexToUse )
 {
 	var $ = this.$,
-		curTabIndex = this.getTabIndex(),
+		curTabIndex = ( indexToUse === undefined ? this.getTabIndex() : indexToUse ),
 		passedCurrent, enteredCurrent,
 		elected,
@@ -265,4 +254,5 @@
  * hitting the TAB key. If set to zero, the TAB key will be used to move the
  * cursor focus to the next element in the page, out of the editor focus.
+ * @name CKEDITOR.config.tabSpaces
  * @type Number
  * @default 0
@@ -270,3 +260,2 @@
  * config.tabSpaces = 4;
  */
-CKEDITOR.config.tabSpaces = 0 ;
Index: CKEditor/trunk/_source/plugins/table/dialogs/table.js
===================================================================
--- CKEditor/trunk/_source/plugins/table/dialogs/table.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/table/dialogs/table.js	(revision 5189)
@@ -340,5 +340,5 @@
 											items :
 											[
-												[ editor.lang.table.alignNotSet , ''],
+												[ editor.lang.common.notSet , ''],
 												[ editor.lang.table.alignLeft , 'left'],
 												[ editor.lang.table.alignCenter , 'center'],
@@ -376,4 +376,16 @@
 													'default' : 200,
 													validate : CKEDITOR.dialog.validate['number']( editor.lang.table.invalidWidth ),
+
+													// Extra labelling of width unit type.
+													onLoad : function()
+													{
+														var widthType = this.getDialog().getContentElement( 'info', 'cmbWidthType' ),
+															labelElement = widthType.getElement(),
+															inputElement = this.getInputElement(),
+															ariaLabelledByAttr = inputElement.getAttribute( 'aria-labelledby' );
+
+														inputElement.setAttribute( 'aria-labelledby', [ ariaLabelledByAttr, labelElement.$.id ].join( ' ' ) );
+													},
+
 													setup : function( selectedTable )
 													{
@@ -389,5 +401,6 @@
 													id : 'cmbWidthType',
 													type : 'select',
-													label : '&nbsp;',
+													label : editor.lang.table.widthUnit,
+													labelStyle: 'visibility:hidden',
 													'default' : 'pixels',
 													items :
@@ -418,4 +431,16 @@
 													'default' : '',
 													validate : CKEDITOR.dialog.validate['number']( editor.lang.table.invalidHeight ),
+
+													// Extra labelling of height unit type.
+													onLoad : function()
+													{
+														var heightType = this.getDialog().getContentElement( 'info', 'htmlHeightType' ),
+															labelElement = heightType.getElement(),
+															inputElement = this.getInputElement(),
+															ariaLabelledByAttr = inputElement.getAttribute( 'aria-labelledby' );
+
+														inputElement.setAttribute( 'aria-labelledby', [ ariaLabelledByAttr, labelElement.$.id ].join( ' ' ) );
+													},
+
 													setup : function( selectedTable )
 													{
@@ -427,6 +452,7 @@
 												},
 												{
+													id : 'htmlHeightType',
 													type : 'html',
-													html : '<br />' + editor.lang.table.widthPx
+													html : '<div><br />' + editor.lang.table.widthPx + '</div>'
 												}
 											]
Index: CKEditor/trunk/_source/plugins/tabletools/dialogs/tableCell.js
===================================================================
--- CKEditor/trunk/_source/plugins/tabletools/dialogs/tableCell.js	(revision 5181)
+++ CKEditor/trunk/_source/plugins/tabletools/dialogs/tableCell.js	(revision 5189)
@@ -105,4 +105,16 @@
 													labelLayout : 'horizontal',
 													validate : validate[ 'number' ]( langCell.invalidWidth ),
+
+													// Extra labelling of width unit type.
+													onLoad : function()
+													{
+														var widthType = this.getDialog().getContentElement( 'info', 'widthType' ),
+															labelElement = widthType.getElement(),
+															inputElement = this.getInputElement(),
+															ariaLabelledByAttr = inputElement.getAttribute( 'aria-labelledby' );
+
+														inputElement.setAttribute( 'aria-labelledby', [ ariaLabelledByAttr, labelElement.$.id ].join( ' ' ) );
+													},
+
 													setup : function( element )
 													{
@@ -132,5 +144,6 @@
 													labelLayout : 'horizontal',
 													widths : [ '0%', '100%' ],
-													label : '',
+													label : editor.lang.table.widthUnit,
+													labelStyle: 'display:none',
 													'default' : 'px',
 													items :
@@ -161,4 +174,16 @@
 													labelLayout : 'horizontal',
 													validate : validate[ 'number' ]( langCell.invalidHeight ),
+
+													// Extra labelling of height unit type.
+													onLoad : function()
+													{
+														var heightType = this.getDialog().getContentElement( 'info', 'htmlHeightType' ),
+															labelElement = heightType.getElement(),
+															inputElement = this.getInputElement(),
+															ariaLabelledByAttr = inputElement.getAttribute( 'aria-labelledby' );
+
+														inputElement.setAttribute( 'aria-labelledby', [ ariaLabelledByAttr, labelElement.$.id ].join( ' ' ) );
+													},
+
 													setup : function( element )
 													{
@@ -182,4 +207,5 @@
 												},
 												{
+													id : 'htmlHeightType',
 													type : 'html',
 													html : langTable.widthPx
